<?php

/**
 * lineas_paa_sigestion actions.
 *
 * @package    contratacion
 * @subpackage lineas_paa_sigestion
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class lineas_paa_sigestionActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $sisgestion = sfConfig::get('app_sisgestion');

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }


        if (isset($request['id_anhos'])) {
            $vigencia = $request['id_anhos'];
        } else {
            $vigencia = date('Y');
        }
        //codigo_dependencia

        if (isset($request['idsisgestiondependencia'])) {
            $cod_depen = $request['idsisgestiondependencia'];
        } else {
            $cod_depen = '';
        }

        //codigo_paa

        if (isset($request['codigopaa'])) {
            $cod_paa = $request['codigopaa'];
        } else {
            $cod_paa = '';
        }


        if (isset($request['usuario'])) {
            $usuario = $request['usuario'];
        } else {
            $usuario = 'SisgestionWebsafi';
        }



        if (isset($request['password'])) {
            $password = $request['password'];
        } else {
            $password = '#ifasbew_$2019';
        }




        //Se trae de la configuracipon la url que se ha establecido en los archivos de configuración
        //$uri=sfConfig::get('app_ipServidorSigestionAutenticacion');
        //$uri=sfConfig::get('app_ipServidorSigestionLineasPaa');

        $uri = $sisgestion . '/api/RequestToken';
        $url = 'http://' . $uri;


        //Se setean los parametros para ejecución
        $parametros_post = 'Username=' . $usuario . '&Password=' . $password;

        //Se inicializa con la URL el cURL
        $sesion = curl_init($url);

        $this->logMessage("LINEAS PAA AURL Llamado: " . $url);
        $this->logMessage("LINEAS PAA Parametros: " . $parametros_post);

        //Define el tipo de ejecución, en este caso POST
        curl_setopt($sesion, CURLOPT_POST, true);
        //Se ingresan los parametos estabelcidos 
        curl_setopt($sesion, CURLOPT_POSTFIELDS, $parametros_post);
        //Parametros de retorno en cURL
        curl_setopt($sesion, CURLOPT_HEADER, false);
        curl_setopt($sesion, CURLOPT_RETURNTRANSFER, true);
        //curl_setopt($sesion, CURLOPT_TIMEOUT_MS, 0.1);
        curl_setopt($sesion, CURLOPT_NOSIGNAL, 0.1);

        //Ejecuta la petición
        $respuesta = curl_exec($sesion);
        //Se cierra la conexión
        curl_close($sesion);

        $this->logMessage("LINEAS PAA Token: " . $respuesta);

        $respuesta = str_replace('"', '', $respuesta);

        /*
         * Manejo de errores
         */
        try {

            /**
             * HOMOLOGACION de EP - 20200416::LAVILA
             */
            $sql = <<<EOD
SELECT
no_estudios_previos,
id_estudios_previos,
no_proceso,
to_char(fecha_creacion,'dd/mm/yyyy') as fecha_creacion,
codigopaa
FROM co_estudios_previos_v
where
codigopaa is not null
and estado = 1 
EOD;


            $resultados_ep = CN_TABLE::executeSQL($sql);

            $respuesta_ep = array();
            foreach ($resultados_ep as $value) {
                $this->logMessage("****************************" . $value['codigopaa']);
                $respuesta_ep [$value['codigopaa']] = $value;
            }



            /**
             * HOMOLOGACION de tabla areas sireci - 20200415::LAVILA
             */
            $sql = <<<EOD
SELECT 

ID_AREA,
DESCRIPCION,
SIGLA,
ID_DEPENDENCIA,
CODIGO,
ID_NIVEL,
ID_COORDINADOR,
AREA_SISGESTION

FROM AREA

WHERE 
AREA_SISGESTION is not null 
EOD;


            $resultados_area = CN_TABLE::executeSQL($sql);

            $respuesta_area = array();
            foreach ($resultados_area as $value) {
                $this->logMessage("****************************" . $value['area_sisgestion']);
                $respuesta_area[$value['area_sisgestion']] = $value;
            }


            $uridos = $sisgestion . '/api/ServicePaa';
            $urldos = 'http://' . $uridos;


            if (isset($request['idsisgestiondependencia'])) {

                if (isset($request['codigopaa'])) {

                    $post = '{
	"Vigencia":' . $vigencia . ','
                            . '"CodigoDependencia":' . $cod_depen . ','
                            . '"CodigoPaa":"' . $cod_paa . '"}';
                } else {

                    $post = '{
	"Vigencia":' . $vigencia . ','
                            . '"CodigoDependencia":' . $cod_depen . '}';
                }
            } else {


                $post = '{
	"Vigencia":' . $vigencia . '}';
            }


            $authorization = "Authorization: Bearer " . $respuesta;

            $sesion = curl_init($urldos);

            curl_setopt($sesion, CURLOPT_HTTPHEADER, array('Content-Type: application/json', $authorization));
            curl_setopt($sesion, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($sesion, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($sesion, CURLOPT_POSTFIELDS, $post);
            curl_setopt($sesion, CURLOPT_FOLLOWLOCATION, 1);
            $result = curl_exec($sesion);
            $resultt = array();
            $respuesta = array();
            curl_close($sesion);
            $resultt = json_decode($result);
            $this->logMessage("LINEAS PAA Respuesta: " . $result);



            foreach ($resultt as $res) {
                $record = array();
                foreach ($res as $key => $value) {
                    if (is_array($value)) {

                        $key = strtolower($key);
                        $re = array();
                        foreach ($value as $va) {
                            $r = array();
                            foreach ($va as $ke => $val) {
                                $ke = strtolower($ke);

                                $r[strtolower($ke)] = $val;
                            }
                            $re[] = $r;
                        }
                        $re = json_encode($re);

                        $record[strtolower($key)] = $re;
                    } else {

                        $key = strtolower($key);
                        $record[strtolower($key)] = $value;
                        $record['id_anhos'] = $vigencia;
                    }
                }
                $id_ano = $record['id_anhos'];
                $cod = $record['codigopaa'];
                $valor = $record['valorvigencia'];
                $codunspsc = $record['codigosunspsc'];
                $codunspsc = str_replace(";", "", $codunspsc);
                $record['desc'] = "Año: " . $id_ano . " -Codigo Paa: " . $cod . " -Valor: " . $valor . " -Codigo Sunspsc" . $codunspsc . " ";
                $record['descdos'] = " Codigo Paa: " . $cod . " -Valor" . $valor;

                //Se completa la nombredependecia - 20200416::LAVILA
                $sis = $record['idsisgestiondependencia'];
                $record['nombredependecia'] = $respuesta_area[$sis]['descripcion'];

                $record['no_estudios_previos'] = $respuesta_ep[$cod]['no_estudios_previos'];
                $record['id_estudios_previos'] = $respuesta_ep[$cod]['id_estudios_previos'];
                $record['no_proceso'] = $respuesta_ep[$cod]['no_proceso'];
                $record['fecha_creacion'] = $respuesta_ep[$cod]['fecha_creacion'];

                
                $respuesta[] = $record;
            }



            $this->totalRows = count($respuesta);
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($respuesta);
            $this->list_data = $respuesta;
            $this->logMessage("[lineas_paa_sigestion] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    function escapeJsonString($value) { # list from www.json.org: (\b backspace, \f formfeed)
        $escapers = array("\\", "/", "\"", "\n", "\r", "\t", "\x08", "\x0c");
        $replacements = array("\\\\", "\\/", "\\\"", "\\n", "\\r", "\\t", "\\f", "\\b");
        $result = str_replace($escapers, $replacements, $value);
        return $result;
    }

}
